<?php

// Script compteur_simple
// version 1.0
// Date 26/09/2017
// Copyright Maxou.fr

// paramtres  remplir
$ParamGlobal['Base_Hote']="*******************";
$ParamGlobal['Base_Utilisateur']="*******************";
$ParamGlobal['Base_MotDePasse']="*******************";
$ParamGlobal['Base_Base']="*******************";
$table="scripts";

// Connexion  la base de donnes
$link = mysqli_connect($ParamGlobal['Base_Hote'], $ParamGlobal['Base_Utilisateur'], $ParamGlobal['Base_MotDePasse'], $ParamGlobal['Base_Base']);
if (mysqli_connect_errno()) 
	{
	// si une erreur de connexion alors n'affiche rien et arrte le script
	exit();
	}

// quelques paramtres 
$file=pathinfo(__FILE__, PATHINFO_BASENAME);
$source=basename($_SERVER['PHP_SELF']);

// Determination du quantime de la journe
$date_quantieme=date('Ymd');
$table_ip=$table."_ip";

// affiche soit le compteur soit les statistiques
if ($source<>$file)
{

//-------------------------------
// SCRIPT COMPTEUR
//-------------------------------

// Recherche dans la base du total
$req_01 = "SELECT total FROM `$table` where `quantieme`='".$date_quantieme."' ORDER BY `quantieme` DESC LIMIT 1 ; ";
$res_01 = $link->query($req_01);
// Si on a un resultat
if ( $res_01->num_rows > 0 )
	{
	//la ligne du jour existe pour le compteur
	}
	else
	{
	// On n'a pas de rsultat pour aujourd'hui
	// je cherche le total prcdent
	$req_02 = "SELECT total FROM `$table` where `quantieme`<'".$date_quantieme."' ORDER BY `quantieme` DESC ;";
	$res_02 = $link->query($req_02);
	if ( $res_02->num_rows > 0 )
		{
		// On a le rsultat suivant
		$result_02 = mysqli_fetch_array($res_02);
		$total_precedent = $result_02["total"];
		}
		else
		{
		// On cr les deux tables ncessaires
		$req_03 = "CREATE TABLE `$table` ( `quantieme` int(20) NOT NULL,  `00h` int(20) NOT NULL,  `01h` int(20) NOT NULL,  `02h` int(20) NOT NULL,  `03h` int(20) NOT NULL,  `04h` int(20) NOT NULL,  `05h` int(20) NOT NULL,  `06h` int(20) NOT NULL,  `07h` int(20) NOT NULL,  `08h` int(20) NOT NULL,  `09h` int(20) NOT NULL,  `10h` int(20) NOT NULL,  `11h` int(20) NOT NULL,  `12h` int(20) NOT NULL,  `13h` int(20) NOT NULL,  `14h` int(20) NOT NULL,  `15h` int(20) NOT NULL,  `16h` int(20) NOT NULL,  `17h` int(20) NOT NULL,  `18h` int(20) NOT NULL,  `19h` int(20) NOT NULL,  `20h` int(20) NOT NULL,  `21h` int(20) NOT NULL,  `22h` int(20) NOT NULL,  `23h` int(20) NOT NULL,  `total_j` int(20) NOT NULL,  `total` int(20) NOT NULL) ENGINE=MyISAM DEFAULT CHARSET=utf8;" ;
		$res_03 = $link->query($req_03);
		$req_04 = "CREATE TABLE `$table_ip` ( `ip` varchar(50) NOT NULL,  `date` int(10) NOT NULL) ENGINE=MyISAM DEFAULT CHARSET=utf8;" ;
		$res_04 = $link->query($req_04);
		$req_05 = "ALTER TABLE `$table` ADD KEY `quantieme` (`quantieme`);" ;
		$res_05 = $link->query($req_05);
		$req_06 = "ALTER TABLE `$table_ip` ADD KEY `ip` (`ip`);" ;
		$res_06 = $link->query($req_06);
		$req_07 = "ALTER TABLE `$table` ADD UNIQUE(`quantieme`);" ;
		$res_07 = $link->query($req_07);
		$req_08 = "ALTER TABLE `$table_ip` ADD UNIQUE(`ip`);" ;
		$res_08 = $link->query($req_08);

		$total_precedent = "0";
		}
	// ajout de la ligne du jour
	$req_09 = "INSERT INTO `$table` (`quantieme`, `00h`, `01h`, `02h`, `03h`, `04h`, `05h`, `06h`, `07h`, `08h`, `09h`, `10h`, `11h`, `12h`, `13h`, `14h`, `15h`, `16h`, `17h`, `18h`, `19h`, `20h`, `21h`, `22h`, `23h`, `total_j`, `total`) VALUES ('".$date_quantieme."', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0', '".$total_precedent."');" ;
	$res_09 = $link->query($req_09);
	}

// verifie si le visiteur est dj dans la base de donnes
if (function_exists('get_client_ip')) 
	{
	// pas besoin de la redclarer 
	}
	else
	{
	function get_client_ip() 
		{
		$ipaddress = '';
		if (getenv('HTTP_CLIENT_IP'))
			$ipaddress = getenv('HTTP_CLIENT_IP');
		else if(getenv('HTTP_X_FORWARDED_FOR'))
			$ipaddress = getenv('HTTP_X_FORWARDED_FOR');
		else if(getenv('HTTP_X_FORWARDED'))
			$ipaddress = getenv('HTTP_X_FORWARDED');
		else if(getenv('HTTP_FORWARDED_FOR'))
			$ipaddress = getenv('HTTP_FORWARDED_FOR');
		else if(getenv('HTTP_FORWARDED'))
			$ipaddress = getenv('HTTP_FORWARDED');
		else if(getenv('REMOTE_ADDR'))
			$ipaddress = getenv('REMOTE_ADDR');
		else
			$ipaddress = 'UNKNOWN';
		return $ipaddress;
		}
	}

// effacer les valeurs qui ne sont pas du jour
$req_10 = "DELETE FROM `$table_ip` WHERE `$table_ip`.`date` < '".$date_quantieme."' " ;
$res_10 = $link->query($req_10);

// trouver si l'utilisateur est connect aujourd'hui et agir
$user=get_client_ip();
$req_11 = "SELECT * FROM `$table_ip` where `ip`='".$user."' " ;
$res_11 = $link->query($req_11);
if ( $res_11->num_rows > 0 )
	{
	//il est dans notre base de donnes
	}
	else
	{
	// ajout dans la base de donnes
	$req_12 = "INSERT INTO `$table_ip` (`ip`, `date`) VALUES ('".$user."', '".$date_quantieme."'); " ;
	$res_12 = $link->query($req_12);
	// ajout dans les compteurs
	$heure_actuelle=date(H)."h";
	$req_13 = "UPDATE `$table` SET `".$heure_actuelle."` = `".$heure_actuelle."`+1, `total_j` = `total_j`+1, `total` = `total`+1 WHERE `$table`.`quantieme` = ".$date_quantieme."; " ;
	$res_13 = $link->query($req_13);
	}

// affichage des visiteurs
$req_14 = "SELECT total FROM `$table` where `quantieme`='".$date_quantieme."' ORDER BY `quantieme` DESC LIMIT 1 ; ";
$res_14 = $link->query($req_14);
// Si on a un resultat
if ( $res_14->num_rows > 0 )
	{
	//On a le rsultat suivant
	$result_14 = mysqli_fetch_array($res_14);
	$id_14 = $result_14["total"];
	if ($id_14<=1) 
		{
		echo "<a href='".$file."' target=_blank>".$id_14." visiteur</a>";
		}
		else
		{
		echo "<a href='".$file."' target=_blank>".$id_14." visiteurs</a>";
		}
	}

}
else
{
// afficher les statistiques

$req_15 = "SELECT total FROM `$table` where `quantieme`='".$date_quantieme."' ORDER BY `quantieme` DESC LIMIT 1 ; ";
$res_15 = $link->query($req_15);
// Si on a un resultat
if ( $res_15->num_rows > 0 )
	{
	//On a le rsultat suivant
	$result_15 = mysqli_fetch_array($res_15);
	$id_15 = $result_15["total"];
	if ($id_15<=1) 
		{
		$compteur = $id_15." visiteur";
		}
		else
		{
		$compteur = $id_15." visiteurs";
		}
	}

$stats=$_GET['stats'];

if ($stats=="")
	{
	$stats=7;
	$stats_texte="des 7 derniers jours";
	}
if ($stats=="total")
	{
	$limite_stats="";
	$stats_texte="globales";
	}
	else
	{
	$limite_stats="LIMIT ".$stats;
	$stats_texte="des ".$stats." derniers jours";
	}

$req_16 = "SELECT * FROM `$table` ORDER BY `quantieme` DESC ".$limite_stats." ; ";
$res_16 = $link->query($req_16);

echo "<HTML>\n";
echo "<HEAD>\n";
echo "<title>Statistiques</title>";
echo "</HEAD>\n";
echo "<BODY><br>\n";
echo "Voici les statistiques pour votre site : ".$compteur." &agrave ce jour.<br>";
echo "<br>";
echo "Voici les statistiques ".$stats_texte." :<br>";
echo "<table>";
echo "<tr><td>Date</td><td>00h</td><td>01h</td><td>02h</td><td>03h</td><td>04h</td><td>05h</td><td>06h</td><td>07h</td><td>08h</td><td>09h</td><td>10h</td><td>11h</td><td>12h</td><td>13h</td><td>14h</td><td>15h</td><td>16h</td><td>17h</td><td>18h</td><td>19h</td><td>20h</td><td>21h</td><td>22h</td><td>23h</td><td>Total</td></tr>";
while ($data_16 = mysqli_fetch_assoc($res_16)) 
	{
	// on affiche les rsultats
	$date19['date']=substr($data_16['quantieme'],6,2)."/".substr($data_16['quantieme'],4,2)."/".substr($data_16['quantieme'],0,4);
	echo "<tr><td>".$date19['date']."</td><td><center>".$data_16['00h']."</td><td><center>".$data_16['01h']."</td><td><center>".$data_16['02h']."</td><td><center>".$data_16['03h']."</td><td><center>".$data_16['04h']."</td><td><center>".$data_16['05h']."</td><td><center>".$data_16['06h']."</td><td><center>".$data_16['07h']."</td><td><center>".$data_16['08h']."</td><td><center>".$data_16['09h']."</td><td><center>".$data_16['10h']."</td><td><center>".$data_16['11h']."</td><td><center>".$data_16['12h']."</td><td><center>".$data_16['13h']."</td><td><center>".$data_16['14h']."</td><td><center>".$data_16['15h']."</td><td><center>".$data_16['16h']."</td><td><center>".$data_16['17h']."</td><td><center>".$data_16['18h']."</td><td><center>".$data_16['19h']."</td><td><center>".$data_16['20h']."</td><td><center>".$data_16['21h']."</td><td><center>".$data_16['22h']."</td><td><center>".$data_16['23h']."</td><td><center>".$data_16['total_j']."</td></tr>";
	}
echo "</table>";
//echo "Stats : ".$stats."<br>";
echo "---> <a href='".$file."'><font color=blue>voir les 7 derniers jours</font></a> || ---> <a href='".$file."?stats=15'><font color=blue>voir les 15 derniers jours</font></a> || ---> <a href='".$file."?stats=30'><font color=blue>voir les 30 derniers jours</font></a> || ---> <a href='".$file."?stats=total'><font color=blue>voir toutes les archives</font></a>.<br>";
echo "<br>";
echo "Copyright &copy 2017 <a href='http://scripts.maxou.fr/' target=_blank><font color=blue>scripts.maxou.fr</font></a>";
echo "</BODY>\n";
echo "</HTML>\n";

}

// nettoyage des donnes et fermeture de la base sql
mysqli_free_result($res_01);
mysqli_free_result($res_02);
mysqli_free_result($res_03);
mysqli_free_result($res_04);
mysqli_free_result($res_05);
mysqli_free_result($res_06);
mysqli_free_result($res_07);
mysqli_free_result($res_08);
mysqli_free_result($res_09);
mysqli_free_result($res_10);
mysqli_free_result($res_11);
mysqli_free_result($res_12);
mysqli_free_result($res_13);
mysqli_free_result($res_14);
mysqli_free_result($res_15);
mysqli_free_result($res_16);
mysqli_close($link);

?>